<?xml version="1.0" encoding="UTF-8"?>
<!-- Vektis ei VZ805 1.0 - 07-11-2018 -->
<!-- VZ805v1.0_XSLT_264u2, 22-02-2019 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ave="http://ei.vektis.nl/aanenafmeldingverzekerde/basisschema/v1_0" xmlns:vz805="http://ei.vektis.nl/aanenafmeldingverzekerde/vz805/v1_0" xmlns:vz806="http://ei.vektis.nl/aanenafmeldingverzekerde/vz806/v1_0" >
		
 	<xsl:import href="rc8028.xslt"/>
 	<xsl:import href="rc8986.xslt"/>
 	<xsl:import href="rc9119.xslt"/>
 	<xsl:import href="rc0435a.xslt"/>
 	<xsl:import href="rc0350.xslt"/>
 	 	
	<!-- Uitvoer is vz806 (val = validated) bericht met Retourcodes. -->
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" />
		
		<xsl:variable name="Verzenddatum" select="translate(vz805:Bericht/vz805:Header/vz805:Verzenddatum, '-', '')"/>
		<xsl:variable name="BerichtSoort" select="//vz805:Bericht/vz805:Header/vz805:BerichtSoort"/>

		<xsl:template match="//vz805:Bericht">
		<vz806:Bericht>
			<xsl:attribute name="xsi:schemaLocation">http://ei.vektis.nl/aanenafmeldingverzekerde/vz806/v1_0 vz806_265.xsd</xsl:attribute>
			<xsl:apply-templates select="vz805:Header"/>
			<xsl:apply-templates select="vz805:Verdragsgerechtigde"/>
		</vz806:Bericht>
	</xsl:template>
	
	<xsl:template match="vz805:Header">
		<vz806:Header>
			<vz806:Berichtcode>265</vz806:Berichtcode>
			<xsl:apply-templates select="vz805:BerichtVersie" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:BerichtSubversie" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:BerichtSoort" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:VerzendendOrgaan"/>
			<xsl:apply-templates select="vz805:OntvangendOrgaan"/>
			<xsl:apply-templates select="vz805:AfzenderReferentienummer" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:Verzenddatum" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:ReferentienummerCAK" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:ReferentienummerZorgverzekeraar" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:AantalBijgevoegdeDocumenten" mode="copy-if-exists"/>
			<vz806:Retourcodes>
				
				<!-- retourcode 8028: Soort bericht ontbreekt of is onjuist. -->
				<xsl:variable name="rc8028">
					<xsl:call-template name="rc8028">
						<xsl:with-param name="BerichtSoort" select="$BerichtSoort"/>
					</xsl:call-template>
				</xsl:variable>

				<!-- retourcode 8986: Verzenddatum moet kleiner zijn dan of gelijk zijn aan de huidige datum. -->
				<xsl:variable name="rc8986">
					<xsl:call-template name="rc8986">
						<xsl:with-param name="Verzenddatum" select="$Verzenddatum"/>
						<xsl:with-param name="BerichtSoort" select="$BerichtSoort"/>
					</xsl:call-template>
				</xsl:variable>
				
				<xsl:copy-of select="$rc8028"/>
				<xsl:copy-of select="$rc8986"/>
				
				<!-- Wanneer de klasse correct is dan wordt een 0200 retourcode toegevoegd. -->
				<xsl:if test="$rc8028='' and $rc8986=''">
					<vz806:Retourcode>0200</vz806:Retourcode>
				</xsl:if>

			</vz806:Retourcodes>
		</vz806:Header>
	</xsl:template>
	
	<xsl:template match="vz805:VerzendendOrgaan">
		<vz806:VerzendendOrgaan>
			<xsl:copy-of select="ave:LandcodeOrgaan"/>
			<xsl:copy-of select="ave:CodeOrgaan"/>
			<xsl:copy-of select="ave:NaamOrgaan"/>
		</vz806:VerzendendOrgaan>
	</xsl:template>	
	
	<xsl:template match="vz805:OntvangendOrgaan">
		<vz806:OntvangendOrgaan>
			<xsl:copy-of select="ave:LandcodeOrgaan"/>
			<xsl:copy-of select="ave:CodeOrgaan"/>
			<xsl:copy-of select="ave:NaamOrgaan"/>			
		</vz806:OntvangendOrgaan>
	</xsl:template>		
	
	<xsl:template match="vz805:Verdragsgerechtigde">
		<vz806:Verdragsgerechtigde>
			<xsl:apply-templates select="vz805:PersoonsgegevensVerdragsgerechtigde"/>
			<xsl:apply-templates select="vz805:AdresgegevensVerdragsgerechtigde"/>
			
			<vz806:Retourcodes>
				
				<!-- retourcode 9119: PINBuitenlandLandCode moet voorkomen als PINBuitenlandBSN voorkomt. -->
				<xsl:variable name="rc9119">
					<xsl:call-template name="rc9119">
						<xsl:with-param name="PINBuitenlandLandCode" select="/vz805:Bericht/vz805:Verdragsgerechtigde/vz805:PersoonsgegevensVerdragsgerechtigde/vz805:PINBuitenlandLandcode"/>
						<xsl:with-param name="PINBuitenlandBSN" select="/vz805:Bericht/vz805:Verdragsgerechtigde/vz805:PersoonsgegevensVerdragsgerechtigde/vz805:PINBuitenlandBSN"/>
					</xsl:call-template>
				</xsl:variable>
				
				<!-- retourcode 0435a: Burgerservicenummer (BSN) verzekerde ontbreekt of is onjuist.11-proef -->
				<xsl:variable name="rc0435a">
					<xsl:call-template name="rc0435a">
						<xsl:with-param name="Bsn" select="/vz805:Bericht/vz805:Verdragsgerechtigde/vz805:PersoonsgegevensVerdragsgerechtigde/vz805:PINBSN"/>
						<xsl:with-param name="BerichtSoort" select="$BerichtSoort"/>
					</xsl:call-template>
				</xsl:variable>			
			
			<!-- retourcode 0350: Geboortedatum moet kleiner zijn dan huidige datum. -->
				<xsl:variable name="rc0350">
					<xsl:call-template name="rc0350">
						<xsl:with-param name="Geboortedatum" select="translate(/vz805:Bericht/vz805:Verdragsgerechtigde/vz805:PersoonsgegevensVerdragsgerechtigde/vz805:Geboortedatum, '-', '')"/>
					</xsl:call-template>
				</xsl:variable>
				
			<xsl:copy-of select="$rc9119"/>
			<xsl:copy-of select="$rc0435a"/>
			<xsl:copy-of select="$rc0350"/>
			
			<!-- Wanneer de klasse correct is dan wordt een 0200 retourcode toegevoegd. -->
				<xsl:if test="$rc9119='' and $rc0435a='' and $rc0350=''">
					<vz806:Retourcode>0200</vz806:Retourcode>
				</xsl:if>
				
			</vz806:Retourcodes>
			
			<xsl:apply-templates select="vz805:Recht"/>
		
		</vz806:Verdragsgerechtigde>
	</xsl:template>
		
	<xsl:template match="vz805:PersoonsgegevensVerdragsgerechtigde">
		<vz806:PersoonsgegevensVerdragsgerechtigde>
			<xsl:apply-templates select="vz805:PINBSN" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:PINVerzekerdenNummer" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:PINBuitenlandBSN" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:PINBuitenlandLandcode" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:PINBuitenlandVerzekerdenNummer" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:Geboortedatum" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:GeslachtCode" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:Voornamen" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:Familienaam" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:FamilienaamGeboorte" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:Geboorteplaats" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:Geboorteland" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:Nationaliteit" mode="copy-if-exists"/>
		</vz806:PersoonsgegevensVerdragsgerechtigde>
	</xsl:template>
	
	<xsl:template match="vz805:AdresgegevensVerdragsgerechtigde">
		<vz806:AdresgegevensVerdragsgerechtigde>
			<xsl:apply-templates select="vz805:StraatnaamHuisnummer" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:Plaats" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:Postcode" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:Regio" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:LandCodeAdres" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:DatumWoonachtigLand" mode="copy-if-exists"/>
		</vz806:AdresgegevensVerdragsgerechtigde>				
	</xsl:template>
				
	<xsl:template match="vz805:Recht">
		<vz806:Recht>
			<xsl:apply-templates select="vz805:EindeRecht"/>
				<vz806:Retourcodes>
					<vz806:Retourcode>0200</vz806:Retourcode>
				</vz806:Retourcodes>	
			</vz806:Recht>
	</xsl:template>	

	<xsl:template match="vz805:EindeRecht">
		<vz806:EindeRecht>
			<xsl:apply-templates select="vz805:TypeVerwijsDocument" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:VerzenddatumVerwijsDocument" mode="copy-if-exists"/>
			<xsl:apply-templates select="vz805:NieuweEinddatum" mode="copy-if-exists"/>
		</vz806:EindeRecht>
	</xsl:template>

<!-- Copy template: als een enkel element voorkomt, wordt deze gekopieerd in de opgegeven namespace -->
	<xsl:template match="*" mode="copy-if-exists">
		<xsl:param name="NameSpacePrefix" select="'vz806:'"/>
		<xsl:if test=".">
			<xsl:element name="{concat($NameSpacePrefix,local-name())}">
				<xsl:value-of select="text()"/>
			</xsl:element>
		</xsl:if>
	</xsl:template>	

</xsl:stylesheet>
